// shared styles
@use "sass:math";

.btn, .btn-flat {
  border: none;
  border-radius: 2px;
  display: inline-block;
  height: $button-height;
  line-height: $button-line-height;
  outline-width: 0;
  padding: 0 .9rem;
  text-transform: uppercase;
  vertical-align: middle;
  // Gets rid of tap active state
  -webkit-tap-highlight-color: transparent;
  &:focus{
    outline-width:5px;
  }
}
// Disabled shared style
.btn.disabled, .btn-floating.disabled, .btn-large.disabled, .btn:disabled, .btn-large:disabled {
  opacity: .3;
  box-shadow: none;
  cursor: default;
  * {
    pointer-events: none;
  }
}
// Shared icon styles
.btn, .btn-large, .btn-flat {
  i {
    font-size: $button-font-size-shared;
    line-height: inherit;
  }
}

// Raised Button
.btn {
  text-decoration:none;
  color: $button-color-raised;
  background-color: $button-color;
  text-align: center;
  letter-spacing: .2px;
  font-size:.933rem;
  display: inline-flex;
  flex-shrink:0;
  justify-content: center;
  @extend .z-depth-half;
  @include transition(.1s ease-out);
  cursor: pointer;
  font-weight: 500;

  &:hover {
    background-color: lighten($button-color, 5%);
  }
}

.btn-inner{
  display: inline-flex;
}

// Large button
.btn-large {
  @extend .btn;
  height: $button-height * 1.5;
  line-height: $button-height * 1.5;

  i {
    font-size: $button-large-icon-font-size;
  }
}

$button-small-icon-font-size:1.4rem;

.btn-medium {
  @extend .btn;
  height:1.8rem;
  line-height: 1.8rem;
  padding:0 .5rem;
  i {
    font-size:$button-font-size-shared;
  }
}

.btn-small {
  @extend .btn;
  height: math.div($button-height, 1.8);
  line-height: math.div($button-height, 1.8);
  padding:0 .2rem;
  i {
    font-size: $button-small-icon-font-size;
  }
}

$button-rounded-small:math.div($button-height, 1.3);

.btn-round{
  border-radius:100%;
  padding:0;
  &.btn{
    width: $button-height;
  }
  &.btn-small{
    height: $button-rounded-small;
    line-height: $button-rounded-small;
    width:$button-rounded-small;
  }
}

// Block button
.btn-block {
  display: block;
}

.btn-primary{
  background:$primary-color;
  &:hover{
    background:lighten($primary-color,10%);
  }
}

$button-secondary-icon-color:#999;
$button-secondary-text-color:#666;

.btn-secondary{
  background:$secondary-button-color;
  color:$button-secondary-text-color;
  .mdi{
    color:darken($button-secondary-icon-color,20%);
  }
  &.btn-flat .mdi{
    color:$button-secondary-icon-color;
  }
  &:hover{
    background: darken($secondary-button-color,5%);
    color:#000;
  }
  &:focus{
    outline-width: 0;
    background:$primary-color;
    color:#fff;
    i{color:#fff;}
  }
  &:active{
    background: lighten($secondary-button-color,5%);
  }
}

.btn-secondary.btn-flat{
  background:transparent;
  &:hover i{
    color:#000;
  }
  &:focus,&:active{
    background:#e5e5e5;
    i{color:#000;}
  }
}

$button-color-flat:$primary-color;

// Flat button
.btn-flat {
  box-shadow: none;
  background-color: transparent;
  color: $button-color-flat;
  cursor: pointer;
  &:hover{
    background:rgba(0,0,0,0.1);
  }
  &:focus{
    background:rgba(0,0,0,0.1);
    outline-width: 0;
  }
  &.disabled {
    color: lighten(#999, 10%);
    cursor: default;
  }
}

.btn-show-more{
  border:none;
  border-radius:20px;
  color:$icon-grey;
  display: block;
  width:100%;
  margin:10px auto 0;
  padding:.2rem 1.5rem;
  font-size:.866rem;
  background: #f0f0f0;
  text-transform: uppercase;
  font-weight: 500;
  &:hover,
  &:focus{
    background: #e2e2e2;
    color:#333;
    outline-width: 0;
  }
  .mdi{
    font-size:1rem;
  }
}

.btn-icon{
  padding:0;
  font-size:1.2rem;
  line-height: 22px;
  color:#aaa;
  width:22px;
  height:22px;
  background: red;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  align-self: right;
  border-radius: 100%;
  &:hover{
    color:#000;
    background:#f0f0f0;
  }
}

.btn-dropdown{
  .mdi-menu-down{
    font-size:1rem;
  }
  > span{
    display: flex;
  }
}

.button-reset{
  background:transparent;
  border:none;
  text-align: left;
}

.btn-open-new-tab.btn-small{
  i{
    font-size:.9rem;
    color:#aaa;
    &:hover{
      color:#000;
    }
  }
}
